SystemOrganization addCategory: #Spec!

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 17:27'!
getIndexSelector: aNumber

	getIndexSelector := aNumber! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 22:19'!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 17:27'!
setIndexSelector: aNumber

	setIndexSelector := aNumber! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 16:00'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == getListSelector
		ifTrue: [
			self updateList.
			^ super update: aSymbol ].
	aSymbol == getIndexSelector
		ifTrue: [
			self selectionIndex: self getCurrentSelectionIndex.
			^ super update: aSymbol ].
	aSymbol == #allSelections
		ifTrue: [
			self selectionIndex: self getCurrentSelectionIndex.
			self changed.
			^ super update: aSymbol ].! !

Model subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 21:00'!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
contents

	^ {ValueHolder new. ValueHolder new}! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
index

	^ index! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:59'!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:58'!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

!Morph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/14/2011 16:32'!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

ValueHolder subclass: #ComposableValueHolder
	instanceVariableNames: 'block originalValueHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block: block originalValueHolder: originalValueHolder

	^ self new
		block: block;
		originalValueHolder: originalValueHolder;
		yourself! !

!ComposableValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
on: originalValueHolder do: block

	^ self new
		block: block;
		originalValueHolder: originalValueHolder;
		yourself! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block

	^ block! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block: anObject
	
	block := anObject! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
originalValueHolder

	^ originalValueHolder! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:09'!
originalValueHolder: aValueHolder
	
	originalValueHolder := aValueHolder.
	aValueHolder addDependent: self.
	self contents: (self block value: self originalValueHolder contents)! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:08'!
update: aSymbol

	self contents: (self block value: self originalValueHolder contents)! !

!ValueHolder class methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 17:52'!
contents: aValue
	
	^ self new
		contents: aValue;
		yourself! !

Object subclass: #ComposableModel
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 17:47'!
entryPoint: entryPoint

	^ self new
		entryPoint: entryPoint;
		yourself! !

!ComposableModel class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/8/2011 14:12'!
windowSpec

	^ self subclassResponsibility! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph

	^ morph! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph: anObject
	
	morph := anObject! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/8/2011 14:37'!
openWithSpec

	^ (SpecInterpretor buildMorphFor: self) openInWorld! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/8/2011 14:12'!
windowSpec

	^ self class windowSpec! !

ComposableModel subclass: #ListComposableModel
	instanceVariableNames: 'indexHolder listHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ListComposableModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 19:22'!
indexHolder: indexHolder listHolder: listHolder

	^ self new
		indexHolder: indexHolder;
		listHolder: listHolder;
		yourself! !

!ListComposableModel class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/8/2011 14:11'!
windowSpec

	^ {#PluggableListMorph.
	    		#model:. #model.
			#getListSelector:. #getList.
			#getIndexSelector:. #getIndex.
			#setIndexSelector:. #setIndex:}! !

!ListComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 21:07'!
getIndex

	^ self indexHolder index contents ifNil: [ self indexHolder index contents: 0 ]! !

!ListComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 19:29'!
getList

	^ self listHolder contents! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:22'!
indexHolder

	^ indexHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:28'!
indexHolder: anObject
	
	indexHolder := anObject.
	anObject addDependent: self.! !

!ListComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/8/2011 14:22'!
initialize

	super initialize.
	indexHolder := ValueHolder new.
	listHolder := ValueHolder new.! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:22'!
listHolder

	^ listHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:28'!
listHolder: anObject
	
	listHolder := anObject.
	anObject addDependent: self.! !

!ListComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/14/2011 16:40'!
setIndex: anIndex

	self indexHolder index contents: anIndex.
	self indexHolder selection contents: (self getList at: anIndex ifAbsent: [ nil ]).
	self changed: #getIndex! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:40'!
update: aSymbol

	self changed: #getList! !

ComposableModel subclass: #Test
	instanceVariableNames: 'listHolder listHolder2 listModel listModel2 selectionHolder selectionHolder2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!Test commentStamp: '<historical>' prior: 0!
| t |
t:= Test new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).!

!Test classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/14/2011 16:42'!
windowSpec

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel	}.
											#frame:.	(	0@0 corner: 0.5@1)	}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel2	}.
											#frame:.	(	0.5@0 corner: 1@1)	}.
			#title:.					'Test'											}! !

!Test methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 18:13'!
addAll: window

	window
		addMorph: (SpecInterpretor interpretASpec: (self listModel windowSpec))
		frame: (0@0 corner: 0.5@1).
		
	window
		addMorph: (SpecInterpretor interpretASpec: (self listModel2 windowSpec))
		frame: (0.5@0 corner: 1@1).! !

!Test methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:27'!
indexHolder

	^ indexHolder! !

!Test methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:27'!
indexHolder2

	^ indexHolder2! !

!Test methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/14/2011 16:43'!
initialize
	| indexHolder selectionHold |
	
	super initialize.
	
	listHolder := ValueHolder new.
	indexHolder := 0 asValueHolder.
	selectionHold := nil asValueHolder.
	selectionHolder := SelectionValueHolder index: indexHolder selection: selectionHold.
	listHolder2 := ComposableValueHolder on: (selectionHold) do: [:c | c ifNotNil: [ c methodDict keys sort ]].
	selectionHolder2 := SelectionValueHolder index: 0 asValueHolder selection: nil asValueHolder.
	listModel := ListComposableModel indexHolder: selectionHolder listHolder: listHolder.
	listModel2 := ListComposableModel indexHolder: selectionHolder2 listHolder: listHolder2.! !

!Test methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:27'!
listHolder

	^ listHolder! !

!Test methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:27'!
listHolder2

	^ listHolder2! !

!Test methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:30'!
listModel

	^ listModel! !

!Test methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 19:30'!
listModel2

	^ listModel2! !

!Test methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 17:37'!
open

	| window |
	window := StandardWindow new model: self; yourself.
	self addAll: window.
	window openInWorld
	! !

Object subclass: #MorphWrapper
	instanceVariableNames: 'layout morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!MorphWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: morph layout: layout 

	^ self new
		layout: layout;
		morph: morph;
		yourself! !

!MorphWrapper methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 11/14/2011 16:31'!
addIn: aContainer

	aContainer
		addMorph: morph
		fullFrame: layout! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
frame: relFrame
	| frame |
	frame := LayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
	layout := frame! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
fullFrame: anObject
	
	layout := anObject! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: anObject
	
	morph := anObject! !

!Object methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 20:48'!
asValueHolder

	^ ValueHolder contents: self! !

!Object methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 20:47'!
update: aParameter 
	"Receive a change notice from an object of whom the receiver is a 
	dependent. The default behavior is to do nothing; a subclass might want 
	to change itself in some way."

	self triggerEvent: #changed.
	^ self! !

Object subclass: #SpecInterpretor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!SpecInterpretor commentStamp: '<historical>' prior: 0!
#model is a moagic world to swap the symbol to the model object
!

!SpecInterpretor classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/8/2011 14:11'!
buildMorphFor: aComposableModel
	
	^ self interpretASpec: aComposableModel windowSpec model: aComposableModel! !

!SpecInterpretor classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/8/2011 14:26'!
classKeys

	^ Smalltalk keys! !

!SpecInterpretor classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 17:09'!
convertSymbolOfClassToInstance: aSymbol

	^ (Smalltalk at: aSymbol) new! !

!SpecInterpretor classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/8/2011 14:44'!
interpretASpec: aSpec model: aModel
	| instance index |

	aSpec ifNil: [ ^ nil ].
	(aSpec isCollection and: [aSpec isSequenceable]) ifFalse: [ ^ (aSpec respondsTo: #windowSpec)
																	ifTrue: [ self interpretASpec: aSpec windowSpec model: aSpec ]
																	ifFalse: [ aSpec ]. ].
	aSpec isString ifTrue: [ 
			^ aSpec == #model
				ifTrue: [ aModel ]
				ifFalse: [ 
					(self classKeys identityIncludes: aSpec)
						ifTrue: [ self convertSymbolOfClassToInstance: aSpec ]
						ifFalse: [ aSpec ]]].

	" aSpec is an Array "
	instance := self interpretASpec: aSpec first model: aModel.
	
	index := 2.	
	
	[ index <= aSpec size ]
		whileTrue: [ | selector numArgs args result |
			selector := aSpec at: index.
			numArgs := selector numArgs.
			args := aSpec copyFrom: index + 1 to: index + numArgs.
			args := args collect: [:each | self interpretASpec: each model: aModel].
			index := index + numArgs + 1.
			result := instance perform: selector withArguments: args.
			index > aSpec size
				ifTrue: [
					(( instance respondsTo: #model) and: [ instance model respondsTo: #morph: ])
						ifTrue: [ instance model morph: instance ].
					^ self interpretASpec: result model: aModel ]].
	self inspect.
	^ instance! !
